/* Contatore.h */

/*
	ADT StatoContatore

	Nota: StatoContatore , a tutti gli effetti, un ADT, infatti  possibile dichiarare
	una variabile di "tipo" StatoContatore. Ad esempio, all'interno della definizione
	di Contatore c' una variabile (stato) di questo tipo.

	Proprio in quanto ADT,  possibile definire delle funzioni che permettano di lavorare
	con variabili di questo tipo.
*/
typedef enum {NO_ERROR, OVERFLOW, BAD_MAX_VAL} StatoContatore;

void visualizzaStato(StatoContatore c);     /* Stampa a video il valore di una variabile di tipo 'StatoContatore' */


/* ADT Contatore */
typedef struct {
	unsigned int valore;
	unsigned int valore_max;
	StatoContatore stato;
} Contatore;



/* Set di funzioni che agiscono sull'ADT Contatore */

void setMaxVal(Contatore *c, int val);		/* Imposta il valore massimo di conteggio */
void azzera(Contatore *c);			  		/* Azzera il contatore */
void inizializza(Contatore *c,int val);     /* Azzera il contatore e invoca la funzione setMaxVal */
void incrementa(Contatore *c);              /* Incrementa il valore attuale di conteggio */
void visualizza(Contatore c);               /* Visualizza lo stato interno del contatore */
int leggi(Contatore c);                     /* Restituisce il valore attuale di conteggio (non fa il check sull'errore) */
StatoContatore isError(Contatore c);        /* Legge e restituisce lo stato interno del contatore */
